function new = smnReorder(smn,ord)
%
% Re-order a given matrix of (row) SMNs according to ord
%
%	new = smnReorder(smn,ord)
% 
% E.g. smnReorder(smn,[4 3 2 1])
% smn =   10    20    30    40
%    	  50    60    70    80
%
% >> smnReorder(smn,[4 3 2 1])
% ans =
%    40    30    20    10
%    80    70    60    50
% >> 
%
%% -------------------------------------------------

	[r,c]=size(ord);
	if c>r, 
		ord=ord';
		assert(r == 1,'Improper dimension for ORD vector');
	else
		assert(c == 1,'Improper dimension for ORD vector');
	end;

	reorder=sortrows([ord,[1:length(ord)]'],1);
	new=smn(:,[reorder(:,2)]);

   
    
%% -------------------------------------------------

