function [newB,newA]=toMatrix(b,A,samples,dims)

% [newB,newA]=toMatrix(b,A,samples,dims)
%                           <rows>,<cols>
%
% e.g. 
%      newB=toMatrix(b,[],2,3)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

newB=[];
newA=[];

if length(dims) == 2,
	dimB=dims(1);
	dimA=dims(2);
else
	dimB=dims;
	dimA=dims;
end

if ~isempty(b),
   [nB,cB]=size(b);
   assert(nB*cB == samples*dimB, 'check dimensions');
   newB=zeros(samples,dimB);

   idx=1;
   for i=1:samples,
      for j=1:dims,
	newB(i,j)=b(idx);
	idx=idx+1;
      end
   end
end;

if ~isempty(A),
   [nA,cA]=size(A);
   newA=sparse(zeros(samples,dimA));

   idx=1;
   for i=1:dimA:nA,
      newA(idx,:)=A(i,1:dimA);
      idx=idx+1;
   end
end;

