clear all;
close all;
addpath('code/');
addpath('3rd-party/liblinear/matlab/');

% dset can be 'tvgraz', 'wiki' or 'pascal'
dset='wiki'
% change to 1 if you want to see the training 
% data (and aux) posteriors
PLOT=0;

% load ground-truth
gt.tr=load(['data/ground-truth/',dset,'.train']);
gt.te=load(['data/ground-truth/',dset,'.test']);

% load data
load(['data/',dset,'/image_1024.mat']);
load(['data/',dset,'/text_100.mat']);

% Regularization
fprintf('-----------------------------------------------------\n');
fprintf('Obtain image (data) and auxilar (text) models\n');

% try some cross-validation procedure here
% for improved model parameter selection
model_I=train(gt.tr,sparse(I_tr),'-s 0 -c 1000 -B 1 -q');
[pred,acc,smn_tr.I]=predict(gt.tr,sparse(I_tr),model_I,'-b 1 -q');

model_T=train(gt.tr,sparse(T_tr),'-s 0 -c 1000 -B 1 -q');
[pred,acc,smn_tr.T]=predict(gt.tr,sparse(T_tr),model_T,'-b 1 -q');

fprintf('done.\n\n');


% Regularization
fprintf('----------------------------------------\n');
fprintf('Learning regularization operators\n');
labels=sort(unique(gt.tr'));

R={};
c=1;
opts.err=1;
for j=labels,
	idx=find(gt.tr == j);
	aux=smnReorder(smn_tr.T(idx,:),model_T.Label');
	data=smnReorder(smn_tr.I(idx,:),model_I.Label');
	if PLOT,
	   figure,
	   subplot(1,2,1);plotsmn3(aux,opts);
	   title(['Aux. data for class ',num2str(j)]);
	   subplot(1,2,2);plotsmn3(data,opts);
	   title(['Train data for class ',num2str(j)]);
	end;
	fprintf('%d: ',j);
	[R{c},fval,exitflag,output,lambda] = risop2(aux,data);
	c=c+1;
end;


[pred,acc,smn_te.I]=predict(gt.te,sparse(I_va),model_I,'-b 1 -q');
[pred,acc,smn_te.T]=predict(gt.te,sparse(T_va),model_T,'-b 1 -q');
smn_te.I=smnReorder(smn_te.I,model_I.Label');
smn_te.T=smnReorder(smn_te.T,model_T.Label');
% Regularized features 
reg.I=regularize_and_interpolate( smn_te.I, smn_te.T, R );

fprintf('done.\n\n');

% Retrieval
fprintf('-----------------------------------\n');
fprintf('Performing retrieval\n');
optR.remove=1;
optR.metric='CC';
optR.k=10;
[Q,C,RIS]=retrieval(smn_te.I,gt.te,reg.I,gt.te,optR);
RIS

[Q,C,QBSE]=retrieval(smn_te.I,gt.te,smn_te.I,gt.te,optR);
QBSE

fprintf('done.\n');

